斜率优化DP(附hdu3507题解)

Print Article

Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 14936    Accepted Submission(s): 4662


Problem Description
Zero has an old printer that doesn't work well sometimes. As it is antique, he still like to use it to print articles. But it is too old to work for a long time and it will certainly wear and tear, so Zero use a cost to evaluate this degree.
One day Zero want to print an article which has N words, and each word i has a cost Ci to be printed. Also, Zero know that print k words in one line will cost

M is a const number.
Now Zero want to know the minimum cost in order to arrange the article perfectly.
 

Input
There are many test cases. For each test case, There are two numbers N and M in the first line (0 ≤ n ≤ 500000, 0 ≤ M ≤ 1000). Then, there are N numbers in the next 2 to N + 1 lines. Input are terminated by EOF.
 

Output
A single number, meaning the mininum cost to print the article.
 

Sample Input
 
   
5 559575
 
Sample Output
 
   
230
 

Author
Xnozero
 

Source
2010 ACM-ICPC Multi-University Training Contest(7)——Host by HIT 



题意:
给你n个数,问你怎样顺序输出,使得总价值最小。
每一行价值计算公式是上图所示,这里每一行可以输任意个字符,你可将n个字符任意(但按顺序)输出到不同行,
其实类似于切蛋糕,给你n个字符串,问你在中间怎么切,可以切任意刀,使得总价值最小

解析:
这里就是用了斜率优化DP
这个东西理解起来可能有点难,并且网上很多技术博客书写的时候都有点小错误。
本人比较渣,我这里就推荐一个博客,然后说一些它上面的 书写的错误,方便理解。
点击打开链接
这上面还有另外两篇大佬的博客也值得去看一下。
这里应该把MAX改成MIN
斜率优化DP(附hdu3507题解)_第1张图片
 我觉得首先应该理解的是找答案的这部分,因为这部分在代码中是在插入I前面的,不过这只是个人看法。
并且这里有一个致命的错误,误导了我很久就是 这里应该是
kj的斜率<2S[t+1],这里就是当前kj的斜率是小于2S[t+1]的最大斜率

找答案的过程,就是向上述大佬所说的,从头开始,找当前存在数组中不大于2S[t+1]的最大的斜率。因为这道题2S[t+1]是有单调性的,随着t增加而增加,所以说当你前面找过的S[t0+1]的最优斜率,很大机率不是(除了S[t0+1]=S[t+1])S[t+1]的最优解。所有用队列去存,找答案的时候,就在开头找最优解,不满足当前S[t0+1]的解就删掉(因为当前都不是最优解,后面也肯定不是最优解),这样用队列就很方便O(n)的复杂度,而如果不单调,就要用到二分找答案这样总的复杂度就要达到O(nlogn)。
斜率优化DP(附hdu3507题解)_第2张图片

最后这一块内容是当对于i的最优解找到是,将i插入到队列时为在i后面的点服务的情况(k
应该是f[x]=dp[x]-S[x]^2


这里还有一点我没搞懂的是为什么在第二个插入操作时,一定要<=而不用<,即一定要把斜率相同的kj=ji,删掉j点。我感觉不删掉也只是在后面 操作查询(因为在查询中也有加=)和插入中多耗点时间,但交上去就WA了,不知道为什么?

总的来说,感谢上面的博客大佬的教导,斜率优化DP其实将对于dp[i]的找答案的过程进行了优化,使得不需要将比i小的点全部遍历一遍。

复杂度: O(n),如果S[i]不单调,那么就只能用CDQ分治来做,复杂度O(nlogn)



#include 
#include 
using namespace std;

const int MAXN = 5e5 +100;

int sum[MAXN];

int dp[MAXN];
int q[MAXN],head,tail;
int n,m;

int DP(int i,int j)
{
    return dp[j]+(sum[i]-sum[j])*(sum[i]-sum[j])+m;
}

int UP(int i,int j)
{
    return dp[i]+sum[i]*sum[i]-dp[j]-sum[j]*sum[j];
}


int DOWN(int i,int j)
{
    return sum[i]-sum[j];
}

int main()
{

    while(scanf("%d%d",&n,&m)!=EOF)
    {
        sum[0]=0;
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&sum[i]);
        }

        for(int i=1;i<=n;i++)
        {
            sum[i]+=sum[i-1];
        }
        dp[0]=0;
        tail=head=0;
        q[tail++]=0;

        for(int i=1;i<=n;i++)   //head+1


你可能感兴趣的:(斜率优化DP)